Enable unit tests again
[ganeti-github.git] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         test/data/htools \
104         test/data/htools/rapi \
105         test/hs/shelltests \
106         test/autotools \
107         lib \
108         lib/build \
109         lib/client \
110         lib/cmdlib \
111         lib/confd \
112         lib/http \
113         lib/hypervisor \
114         lib/impexpd \
115         lib/masterd \
116         lib/rapi \
117         lib/server \
118         lib/tools \
119         lib/utils \
120         lib/watcher \
121         man \
122         qa \
123         test \
124         test/data \
125         test/data/bdev-rbd \
126         test/data/ovfdata \
127         test/data/ovfdata/other \
128         test/py \
129         tools
130
131 ALL_APIDOC_HS_DIRS = \
132         $(APIDOC_HS_DIR) \
133         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
134
135 BUILDTIME_DIR_AUTOCREATE = \
136         scripts \
137         $(APIDOC_DIR) \
138         $(ALL_APIDOC_HS_DIRS) \
139         $(APIDOC_PY_DIR) \
140         $(COVERAGE_DIR) \
141         $(COVERAGE_HS_DIR) \
142         $(COVERAGE_PY_DIR) \
143         .hpc
144
145 BUILDTIME_DIRS = \
146         $(BUILDTIME_DIR_AUTOCREATE) \
147         doc/html \
148         doc/man-html
149
150 DIRCHECK_EXCLUDE = \
151         $(BUILDTIME_DIRS) \
152         ganeti-[0-9]*.[0-9]*.[0-9]* \
153         doc/html/_* \
154         doc/man-html/_* \
155         autom4te.cache
156
157 # some helper vars
158 COVERAGE_DIR = doc/coverage
159 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
160 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
161 APIDOC_DIR = doc/api
162 APIDOC_PY_DIR = $(APIDOC_DIR)/py
163 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
164
165 MAINTAINERCLEANFILES = \
166         $(maninput) \
167         doc/install-quick.rst \
168         doc/news.rst \
169         doc/upgrade.rst \
170         vcs-version
171
172 maintainer-clean-local:
173         rm -rf $(BUILDTIME_DIRS)
174
175 CLEANFILES = \
176         $(addsuffix /*.py[co],$(DIRS)) \
177         $(addsuffix /*.hi,$(HS_DIRS)) \
178         $(addsuffix /*.o,$(HS_DIRS)) \
179         $(PYTHON_BOOTSTRAP) \
180         epydoc.conf \
181         $(REPLACE_VARS_SED) \
182         $(SHELL_ENV_INIT) \
183         daemons/daemon-util \
184         daemons/ganeti-cleaner \
185         devel/squeeze-amd64.tar.gz \
186         devel/squeeze-amd64.conf \
187         $(mandocrst) \
188         doc/manpages-enabled.rst \
189         $(BUILT_EXAMPLES) \
190         doc/examples/bash_completion \
191         doc/examples/bash_completion-debug \
192         lib/_generated_rpc.py \
193         $(man_MANS) \
194         $(manhtml) \
195         tools/kvm-ifup \
196         tools/users-setup \
197         tools/vcluster-setup \
198         stamp-directories \
199         stamp-srclinks \
200         $(nodist_pkgpython_PYTHON) \
201         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
202         $(HS_BUILT_TEST_HELPERS) \
203         src/ganeti-confd \
204         src/ganeti-queryd \
205         src/ganeti-mond \
206         .hpc/*.mix src/*.tix test/hs/*.tix \
207         doc/hs-lint.html
208
209 GENERATED_FILES = \
210         $(built_base_sources) \
211         $(BUILT_PYTHON_SOURCES) \
212         $(PYTHON_BOOTSTRAP)
213
214 HS_GENERATED_FILES =
215 if WANT_HTOOLS
216 HS_GENERATED_FILES += $(HS_PROGS)
217 if ENABLE_CONFD
218 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hqueryd src/ganeti-queryd
219 endif
220
221 if ENABLE_MOND
222 HS_GENERATED_FILES += src/ganeti-mond
223 endif
224 endif
225
226 built_base_sources = \
227         stamp-directories \
228         stamp-srclinks
229
230 built_python_base_sources = \
231         lib/_autoconf.py \
232         lib/_vcsversion.py
233
234 BUILT_PYTHON_SOURCES = \
235         $(built_python_base_sources) \
236         lib/_generated_rpc.py
237
238 # Generating the RPC wrappers depends on many things, so make sure
239 # it's built at the end of the built sources
240 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
241
242 # these are all built from the underlying %.in sources
243 BUILT_EXAMPLES = \
244         doc/examples/ganeti-kvm-poweroff.initd \
245         doc/examples/ganeti.cron \
246         doc/examples/ganeti.initd \
247         doc/examples/ganeti-master-role.ocf \
248         doc/examples/ganeti-node-role.ocf \
249         doc/examples/gnt-config-backup \
250         doc/examples/hooks/ipsec
251
252 nodist_pkgpython_PYTHON = \
253         $(BUILT_PYTHON_SOURCES)
254
255 noinst_PYTHON = \
256         lib/build/__init__.py \
257         lib/build/shell_example_lexer.py \
258         lib/build/sphinx_ext.py
259
260 pkgpython_PYTHON = \
261         lib/__init__.py \
262         lib/asyncnotifier.py \
263         lib/backend.py \
264         lib/bdev.py \
265         lib/bootstrap.py \
266         lib/cli.py \
267         lib/compat.py \
268         lib/config.py \
269         lib/constants.py \
270         lib/daemon.py \
271         lib/errors.py \
272         lib/hooksmaster.py \
273         lib/ht.py \
274         lib/jqueue.py \
275         lib/jstore.py \
276         lib/locking.py \
277         lib/luxi.py \
278         lib/mcpu.py \
279         lib/netutils.py \
280         lib/objects.py \
281         lib/opcodes.py \
282         lib/outils.py \
283         lib/ovf.py \
284         lib/pathutils.py \
285         lib/qlang.py \
286         lib/query.py \
287         lib/rpc.py \
288         lib/rpc_defs.py \
289         lib/runtime.py \
290         lib/serializer.py \
291         lib/ssconf.py \
292         lib/ssh.py \
293         lib/storage.py \
294         lib/uidpool.py \
295         lib/vcluster.py \
296         lib/network.py \
297         lib/workerpool.py
298
299 client_PYTHON = \
300         lib/client/__init__.py \
301         lib/client/gnt_backup.py \
302         lib/client/gnt_cluster.py \
303         lib/client/gnt_debug.py \
304         lib/client/gnt_group.py \
305         lib/client/gnt_instance.py \
306         lib/client/gnt_job.py \
307         lib/client/gnt_node.py \
308         lib/client/gnt_network.py \
309         lib/client/gnt_os.py \
310         lib/client/gnt_storage.py
311
312 cmdlib_PYTHON = \
313         lib/cmdlib/__init__.py \
314         lib/cmdlib/backup.py \
315         lib/cmdlib/base.py \
316         lib/cmdlib/cluster.py \
317         lib/cmdlib/common.py \
318         lib/cmdlib/group.py \
319         lib/cmdlib/instance.py \
320         lib/cmdlib/instance_migration.py \
321         lib/cmdlib/instance_operation.py \
322         lib/cmdlib/instance_query.py \
323         lib/cmdlib/instance_storage.py \
324         lib/cmdlib/instance_utils.py \
325         lib/cmdlib/misc.py \
326         lib/cmdlib/network.py \
327         lib/cmdlib/node.py \
328         lib/cmdlib/operating_system.py \
329         lib/cmdlib/query.py \
330         lib/cmdlib/tags.py \
331         lib/cmdlib/test.py
332
333 hypervisor_PYTHON = \
334         lib/hypervisor/__init__.py \
335         lib/hypervisor/hv_base.py \
336         lib/hypervisor/hv_chroot.py \
337         lib/hypervisor/hv_fake.py \
338         lib/hypervisor/hv_kvm.py \
339         lib/hypervisor/hv_lxc.py \
340         lib/hypervisor/hv_xen.py
341
342 rapi_PYTHON = \
343         lib/rapi/__init__.py \
344         lib/rapi/baserlib.py \
345         lib/rapi/client.py \
346         lib/rapi/client_utils.py \
347         lib/rapi/connector.py \
348         lib/rapi/rlib2.py \
349         lib/rapi/testutils.py
350
351 http_PYTHON = \
352         lib/http/__init__.py \
353         lib/http/auth.py \
354         lib/http/client.py \
355         lib/http/server.py
356
357 confd_PYTHON = \
358         lib/confd/__init__.py \
359         lib/confd/client.py
360
361 masterd_PYTHON = \
362         lib/masterd/__init__.py \
363         lib/masterd/iallocator.py \
364         lib/masterd/instance.py
365
366 impexpd_PYTHON = \
367         lib/impexpd/__init__.py
368
369 watcher_PYTHON = \
370         lib/watcher/__init__.py \
371         lib/watcher/nodemaint.py \
372         lib/watcher/state.py
373
374 server_PYTHON = \
375         lib/server/__init__.py \
376         lib/server/masterd.py \
377         lib/server/noded.py \
378         lib/server/rapi.py
379
380 pytools_PYTHON = \
381         lib/tools/__init__.py \
382         lib/tools/burnin.py \
383         lib/tools/ensure_dirs.py \
384         lib/tools/node_cleanup.py \
385         lib/tools/node_daemon_setup.py \
386         lib/tools/prepare_node_join.py
387
388 utils_PYTHON = \
389         lib/utils/__init__.py \
390         lib/utils/algo.py \
391         lib/utils/filelock.py \
392         lib/utils/hash.py \
393         lib/utils/io.py \
394         lib/utils/log.py \
395         lib/utils/lvm.py \
396         lib/utils/mlock.py \
397         lib/utils/nodesetup.py \
398         lib/utils/process.py \
399         lib/utils/retry.py \
400         lib/utils/text.py \
401         lib/utils/wrapper.py \
402         lib/utils/x509.py
403
404 docinput = \
405         doc/conf.py \
406         doc/css/style.css \
407         doc/admin.rst \
408         doc/cluster-merge.rst \
409         doc/design-2.0.rst \
410         doc/design-2.1.rst \
411         doc/design-2.2.rst \
412         doc/design-2.3.rst \
413         doc/design-2.4.rst \
414         doc/design-2.5.rst \
415         doc/design-2.6.rst \
416         doc/design-2.7.rst \
417         doc/design-2.8.rst \
418         doc/design-autorepair.rst \
419         doc/design-bulk-create.rst \
420         doc/design-chained-jobs.rst \
421         doc/design-cpu-pinning.rst \
422         doc/design-device-uuid-name.rst \
423         doc/design-draft.rst \
424         doc/design-htools-2.3.rst \
425         doc/design-http-server.rst \
426         doc/design-impexp2.rst \
427         doc/design-lu-generated-jobs.rst \
428         doc/design-linuxha.rst \
429         doc/design-multi-reloc.rst \
430         doc/design-network.rst \
431         doc/design-node-add.rst \
432         doc/design-oob.rst \
433         doc/design-ovf-support.rst \
434         doc/design-opportunistic-locking.rst \
435         doc/design-partitioned.rst \
436         doc/design-query-splitting.rst \
437         doc/design-query2.rst \
438         doc/design-reason-trail.rst \
439         doc/design-resource-model.rst \
440         doc/design-restricted-commands.rst \
441         doc/design-shared-storage.rst \
442         doc/design-monitoring-agent.rst \
443         doc/design-virtual-clusters.rst \
444         doc/design-x509-ca.rst \
445         doc/design-hroller.rst \
446         doc/design-storagetypes.rst \
447         doc/devnotes.rst \
448         doc/glossary.rst \
449         doc/hooks.rst \
450         doc/iallocator.rst \
451         doc/index.rst \
452         doc/install-quick.rst \
453         doc/install.rst \
454         doc/locking.rst \
455         doc/manpages-disabled.rst \
456         doc/move-instance.rst \
457         doc/news.rst \
458         doc/ovfconverter.rst \
459         doc/rapi.rst \
460         doc/security.rst \
461         doc/upgrade.rst \
462         doc/virtual-cluster.rst \
463         doc/walkthrough.rst
464
465 # Generates file names such as "doc/man-gnt-instance.rst"
466 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
467
468 # Haskell programs to be installed in $PREFIX/bin
469 HS_BIN_PROGS=src/htools
470
471 # Haskell programs to be installed in the MYEXECLIB dir
472 if ENABLE_MOND
473 HS_MYEXECLIB_PROGS=src/mon-collector
474 else
475 HS_MYEXECLIB_PROGS=
476 endif
477
478 # Haskell programs to be compiled by "make really-all"
479 HS_COMPILE_PROGS= \
480         src/ganeti-mond \
481         src/hconfd \
482         src/hqueryd \
483         src/rpc-test
484
485 # All Haskell non-test programs to be compiled but not automatically installed
486 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
487
488 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
489 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
490
491 HS_ALL_PROGS = \
492         $(HS_PROGS) \
493         test/hs/hpc-htools \
494         test/hs/hpc-mon-collector \
495         test/hs/htest \
496         $(HS_COMPILE_PROGS)
497
498 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
499 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
500
501 HFLAGS = \
502         -O -Wall -Werror -isrc \
503         -fwarn-monomorphism-restriction \
504         -fwarn-tabs \
505         $(GHC_BYVERSION_FLAGS)
506
507 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
508 HEXTRA =
509 # internal extra flags (used for test/hs/htest mainly)
510 HEXTRA_INT =
511 # exclude options for coverage reports
512 HPCEXCL = --exclude Main \
513         --exclude Ganeti.Constants \
514         --exclude Ganeti.HTools.QC \
515         --exclude Ganeti.THH \
516         --exclude Ganeti.Version \
517         --exclude Test.Ganeti.Attoparsec \
518         --exclude Test.Ganeti.TestCommon \
519         --exclude Test.Ganeti.TestHTools \
520         --exclude Test.Ganeti.TestHelper \
521         --exclude Test.Ganeti.TestImports \
522         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
523
524 HS_LIB_SRCS = \
525         src/Ganeti/Block/Drbd/Types.hs \
526         src/Ganeti/Block/Drbd/Parser.hs \
527         src/Ganeti/BasicTypes.hs \
528         src/Ganeti/Common.hs \
529         src/Ganeti/Compat.hs \
530         src/Ganeti/Confd/Client.hs \
531         src/Ganeti/Confd/Server.hs \
532         src/Ganeti/Confd/Types.hs \
533         src/Ganeti/Confd/Utils.hs \
534         src/Ganeti/Config.hs \
535         src/Ganeti/ConfigReader.hs \
536         src/Ganeti/Curl/Multi.hs \
537         src/Ganeti/Daemon.hs \
538         src/Ganeti/DataCollectors/CLI.hs \
539         src/Ganeti/DataCollectors/Drbd.hs \
540         src/Ganeti/DataCollectors/Program.hs \
541         src/Ganeti/DataCollectors/Types.hs \
542         src/Ganeti/Errors.hs \
543         src/Ganeti/HTools/Backend/IAlloc.hs \
544         src/Ganeti/HTools/Backend/Luxi.hs \
545         src/Ganeti/HTools/Backend/Rapi.hs \
546         src/Ganeti/HTools/Backend/Simu.hs \
547         src/Ganeti/HTools/Backend/Text.hs \
548         src/Ganeti/HTools/CLI.hs \
549         src/Ganeti/HTools/Cluster.hs \
550         src/Ganeti/HTools/Container.hs \
551         src/Ganeti/HTools/ExtLoader.hs \
552         src/Ganeti/HTools/Graph.hs \
553         src/Ganeti/HTools/Group.hs \
554         src/Ganeti/HTools/Instance.hs \
555         src/Ganeti/HTools/Loader.hs \
556         src/Ganeti/HTools/Nic.hs \
557         src/Ganeti/HTools/Node.hs \
558         src/Ganeti/HTools/PeerMap.hs \
559         src/Ganeti/HTools/Program/Hail.hs \
560         src/Ganeti/HTools/Program/Harep.hs \
561         src/Ganeti/HTools/Program/Hbal.hs \
562         src/Ganeti/HTools/Program/Hcheck.hs \
563         src/Ganeti/HTools/Program/Hinfo.hs \
564         src/Ganeti/HTools/Program/Hscan.hs \
565         src/Ganeti/HTools/Program/Hspace.hs \
566         src/Ganeti/HTools/Program/Hroller.hs \
567         src/Ganeti/HTools/Program/Main.hs \
568         src/Ganeti/HTools/Types.hs \
569         src/Ganeti/Hypervisor/Xen/XmParser.hs \
570         src/Ganeti/Hypervisor/Xen/Types.hs \
571         src/Ganeti/Hash.hs \
572         src/Ganeti/JQueue.hs \
573         src/Ganeti/JSON.hs \
574         src/Ganeti/Jobs.hs \
575         src/Ganeti/Logging.hs \
576         src/Ganeti/Luxi.hs \
577         src/Ganeti/Monitoring/Server.hs \
578         src/Ganeti/Network.hs \
579         src/Ganeti/Objects.hs \
580         src/Ganeti/OpCodes.hs \
581         src/Ganeti/OpParams.hs \
582         src/Ganeti/Path.hs \
583         src/Ganeti/Query/Common.hs \
584         src/Ganeti/Query/Export.hs \
585         src/Ganeti/Query/Filter.hs \
586         src/Ganeti/Query/Group.hs \
587         src/Ganeti/Query/Job.hs \
588         src/Ganeti/Query/Language.hs \
589         src/Ganeti/Query/Network.hs \
590         src/Ganeti/Query/Node.hs \
591         src/Ganeti/Query/Query.hs \
592         src/Ganeti/Query/Server.hs \
593         src/Ganeti/Query/Types.hs \
594         src/Ganeti/Rpc.hs \
595         src/Ganeti/Runtime.hs \
596         src/Ganeti/Ssconf.hs \
597         src/Ganeti/THH.hs \
598         src/Ganeti/Types.hs \
599         src/Ganeti/Utils.hs
600
601 HS_TEST_SRCS = \
602         test/hs/Test/Ganeti/Attoparsec.hs \
603         test/hs/Test/Ganeti/BasicTypes.hs \
604         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
605         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
606         test/hs/Test/Ganeti/Common.hs \
607         test/hs/Test/Ganeti/Confd/Types.hs \
608         test/hs/Test/Ganeti/Confd/Utils.hs \
609         test/hs/Test/Ganeti/Daemon.hs \
610         test/hs/Test/Ganeti/Errors.hs \
611         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
612         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
613         test/hs/Test/Ganeti/HTools/CLI.hs \
614         test/hs/Test/Ganeti/HTools/Cluster.hs \
615         test/hs/Test/Ganeti/HTools/Container.hs \
616         test/hs/Test/Ganeti/HTools/Graph.hs \
617         test/hs/Test/Ganeti/HTools/Instance.hs \
618         test/hs/Test/Ganeti/HTools/Loader.hs \
619         test/hs/Test/Ganeti/HTools/Node.hs \
620         test/hs/Test/Ganeti/HTools/PeerMap.hs \
621         test/hs/Test/Ganeti/HTools/Types.hs \
622         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
623         test/hs/Test/Ganeti/JSON.hs \
624         test/hs/Test/Ganeti/Jobs.hs \
625         test/hs/Test/Ganeti/JQueue.hs \
626         test/hs/Test/Ganeti/Luxi.hs \
627         test/hs/Test/Ganeti/Network.hs \
628         test/hs/Test/Ganeti/Objects.hs \
629         test/hs/Test/Ganeti/OpCodes.hs \
630         test/hs/Test/Ganeti/Query/Filter.hs \
631         test/hs/Test/Ganeti/Query/Language.hs \
632         test/hs/Test/Ganeti/Query/Network.hs \
633         test/hs/Test/Ganeti/Query/Query.hs \
634         test/hs/Test/Ganeti/Rpc.hs \
635         test/hs/Test/Ganeti/Runtime.hs \
636         test/hs/Test/Ganeti/Ssconf.hs \
637         test/hs/Test/Ganeti/THH.hs \
638         test/hs/Test/Ganeti/TestCommon.hs \
639         test/hs/Test/Ganeti/TestHTools.hs \
640         test/hs/Test/Ganeti/TestHelper.hs \
641         test/hs/Test/Ganeti/Types.hs \
642         test/hs/Test/Ganeti/Utils.hs
643
644 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
645
646 HS_BUILT_SRCS = \
647         test/hs/Test/Ganeti/TestImports.hs \
648         src/Ganeti/Constants.hs \
649         src/Ganeti/Curl/Internal.hs \
650         src/Ganeti/Version.hs
651 HS_BUILT_SRCS_IN = \
652         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
653         src/Ganeti/Curl/Internal.hsc
654
655 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
656
657 $(RUN_IN_TEMPDIR): | stamp-directories
658
659 doc/html/index.html: ENABLE_MANPAGES =
660 doc/man-html/index.html: ENABLE_MANPAGES = 1
661 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
662
663 # Note: we use here an order-only prerequisite, as the contents of
664 # _autoconf.py are not actually influencing the html build output: it
665 # has to exist in order for the sphinx module to be loaded
666 # successfully, but we certainly don't want the docs to be rebuilt if
667 # it changes
668 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
669         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
670         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
671         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
672         | $(BUILT_PYTHON_SOURCES)
673         @test -n "$(SPHINX)" || \
674             { echo 'sphinx-build' not found during configure; exit 1; }
675 if !MANPAGES_IN_DOC
676         if test -n '$(ENABLE_MANPAGES)'; then \
677           echo 'Man pages in documentation were disabled at configure time' >&2; \
678           exit 1; \
679         fi
680 endif
681 ## Sphinx provides little control over what content should be included. Some
682 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
683 ## build two different versions of the documentation--once without man pages and
684 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
685 ## us with this, but requires running in a temporary directory. It moves the
686 ## correct files into place depending on environment variables.
687         dir=$(dir $@) && \
688         @mkdir_p@ $$dir && \
689         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
690         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
691             -d . \
692             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
693             -D release="$(PACKAGE_VERSION)" \
694             -D graphviz_dot="$(DOT)" \
695             -D enable_manpages="$(ENABLE_MANPAGES)" \
696             doc $(CURDIR)/$$dir && \
697         rm -f $$dir/.buildinfo $$dir/objects.inv
698         touch $@
699
700 doc/html: doc/html/index.html
701
702 doc/man-html: doc/man-html/index.html
703
704 doc/install-quick.rst: INSTALL
705 doc/news.rst: NEWS
706 doc/upgrade.rst: UPGRADE
707
708 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
709         set -e; \
710         { echo '.. This file is automatically updated at build time from $<.'; \
711           echo '.. Do not edit.'; \
712           echo; \
713           cat $<; \
714         } > $@
715
716 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
717         { echo '.. This file is automatically generated, do not edit!'; \
718           echo ''; \
719           echo 'Man pages'; \
720           echo '========='; \
721           echo; \
722           echo '.. toctree::'; \
723           echo '   :maxdepth: 1'; \
724           echo; \
725           for i in $(notdir $(mandocrst)); do \
726             echo "   $$i"; \
727           done | LC_ALL=C sort; \
728         } > $@
729
730 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
731 if MANPAGES_IN_DOC
732         { echo '.. This file is automatically updated at build time from $<.'; \
733           echo '.. Do not edit.'; \
734           echo; \
735           echo "$*"; \
736           echo '=========================================='; \
737           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
738         } > $@
739 else
740         echo 'Man pages in documentation were disabled at configure time' >&2; \
741         exit 1;
742 endif
743
744 # Things to build but not to install (add it to EXTRA_DIST if it should be
745 # distributed)
746 noinst_DATA = \
747         doc/html \
748         $(BUILT_EXAMPLES) \
749         doc/examples/bash_completion \
750         doc/examples/bash_completion-debug \
751         $(manhtml)
752
753 if MANPAGES_IN_DOC
754 noinst_DATA += doc/man-html
755 endif
756
757 gnt_scripts = \
758         scripts/gnt-backup \
759         scripts/gnt-cluster \
760         scripts/gnt-debug \
761         scripts/gnt-group \
762         scripts/gnt-instance \
763         scripts/gnt-job \
764         scripts/gnt-network \
765         scripts/gnt-node \
766         scripts/gnt-os \
767         scripts/gnt-storage
768
769 PYTHON_BOOTSTRAP_SBIN = \
770         daemons/ganeti-masterd \
771         daemons/ganeti-noded \
772         daemons/ganeti-rapi \
773         daemons/ganeti-watcher \
774         $(gnt_scripts)
775
776 PYTHON_BOOTSTRAP = \
777         $(PYTHON_BOOTSTRAP_SBIN) \
778         tools/burnin \
779         tools/ensure-dirs \
780         tools/node-cleanup \
781         tools/node-daemon-setup \
782         tools/prepare-node-join
783
784 qa_scripts = \
785         qa/__init__.py \
786         qa/ganeti-qa.py \
787         qa/qa_cluster.py \
788         qa/qa_config.py \
789         qa/qa_daemon.py \
790         qa/qa_env.py \
791         qa/qa_error.py \
792         qa/qa_group.py \
793         qa/qa_instance.py \
794         qa/qa_job.py \
795         qa/qa_node.py \
796         qa/qa_os.py \
797         qa/qa_rapi.py \
798         qa/qa_tags.py \
799         qa/qa_utils.py
800
801 bin_SCRIPTS =
802 if WANT_HTOOLS
803 bin_SCRIPTS += $(HS_BIN_PROGS)
804 install-exec-hook:
805         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
806 # FIXME: this is a hardcoded logic, instead of auto-resolving
807         $(LN_S) -f ../../../bin/htools \
808           $(DESTDIR)$(iallocatorsdir)/hail
809         for role in $(HS_BIN_ROLES); do \
810           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
811         done
812 endif
813
814 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
815         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
816           echo "Error: cannot run unittests without the development" \
817                " libraries (see devnotes.rst)" 1>&2; \
818           exit 1; \
819         fi
820         @rm -f $(notdir $@).tix
821         $(GHC) --make \
822           $(HFLAGS) \
823           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
824           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
825           $(HEXTRA) $(HEXTRA_INT) $@
826         @touch "$@"
827
828 # for the test/hs/htest binary, we need to enable profiling/coverage
829 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
830
831 # we compile the hpc-htools binary with the program coverage
832 test/hs/hpc-htools: HEXTRA_INT=-fhpc
833
834 # we compile the hpc-mon-collector binary with the program coverage
835 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
836
837 # test dependency
838 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
839
840 # rules for building profiling-enabled versions of the haskell
841 # programs: hs-prof does the full two-step build, whereas
842 # hs-prof-quick does only the final rebuild (hs-prof must have been
843 # run before)
844 .PHONY: hs-prof hs-prof-quick
845 hs-prof:
846         @if [ -z "$(TARGET)" ]; then \
847           echo "You need to define TARGET when running this rule" 1>&2; \
848           exit 1; \
849         fi
850         $(MAKE) $(AM_MAKEFLAGS) clean
851         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
852         rm -f $(HS_ALL_PROGS)
853         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
854
855 hs-prof-quick:
856         @if [ -z "$(TARGET)" ]; then \
857           echo "You need to define TARGET when running this rule" 1>&2; \
858           exit 1; \
859         fi
860         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
861
862 dist_sbin_SCRIPTS = \
863         tools/ganeti-listrunner
864
865 nodist_sbin_SCRIPTS = \
866         $(PYTHON_BOOTSTRAP_SBIN) \
867         daemons/ganeti-cleaner
868
869 if ENABLE_CONFD
870 src/ganeti-confd: src/hconfd
871         cp -f $< $@
872
873 src/ganeti-queryd: src/hqueryd
874         cp -f $< $@
875
876 nodist_sbin_SCRIPTS += src/ganeti-confd
877 nodist_sbin_SCRIPTS += src/ganeti-queryd
878 endif
879
880 if ENABLE_MOND
881 nodist_sbin_SCRIPTS += src/ganeti-mond
882 endif
883
884 python_scripts = \
885         tools/cfgshell \
886         tools/cfgupgrade \
887         tools/cfgupgrade12 \
888         tools/cluster-merge \
889         tools/confd-client \
890         tools/fmtjson \
891         tools/lvmstrap \
892         tools/move-instance \
893         tools/ovfconverter \
894         tools/sanitize-config
895
896 dist_tools_SCRIPTS = \
897         $(python_scripts) \
898         tools/burnin \
899         tools/kvm-console-wrapper \
900         tools/master-ip-setup \
901         tools/xen-console-wrapper
902
903 nodist_tools_python_scripts = \
904         tools/node-cleanup
905
906 nodist_tools_SCRIPTS = \
907         $(nodist_tools_python_scripts) \
908         tools/users-setup \
909         tools/vcluster-setup
910
911 pkglib_python_scripts = \
912         daemons/import-export \
913         tools/check-cert-expired
914
915 nodist_pkglib_python_scripts = \
916         tools/ensure-dirs \
917         tools/node-daemon-setup \
918         tools/prepare-node-join
919
920 myexeclib_SCRIPTS = \
921         daemons/daemon-util \
922         tools/kvm-ifup \
923         $(pkglib_python_scripts) \
924         $(HS_MYEXECLIB_PROGS)
925
926 nodist_myexeclib_SCRIPTS = \
927         $(nodist_pkglib_python_scripts)
928
929 EXTRA_DIST = \
930         NEWS \
931         UPGRADE \
932         epydoc.conf.in \
933         pylintrc \
934         autotools/build-bash-completion \
935         autotools/build-rpc \
936         autotools/check-header \
937         autotools/check-imports \
938         autotools/check-man-dashes \
939         autotools/check-man-references \
940         autotools/check-man-warnings \
941         autotools/check-news \
942         autotools/check-python-code \
943         autotools/check-tar \
944         autotools/check-version \
945         autotools/convert-constants \
946         autotools/docpp \
947         autotools/gen-py-coverage \
948         autotools/sphinx-wrapper \
949         autotools/testrunner \
950         autotools/wrong-hardcoded-paths \
951         $(RUN_IN_TEMPDIR) \
952         daemons/daemon-util.in \
953         daemons/ganeti-cleaner.in \
954         $(pkglib_python_scripts) \
955         devel/upload \
956         devel/webserver \
957         tools/kvm-ifup.in \
958         tools/users-setup.in \
959         tools/vcluster-setup.in \
960         $(docinput) \
961         doc/html \
962         $(BUILT_EXAMPLES:%=%.in) \
963         doc/examples/ganeti.default \
964         doc/examples/ganeti.default-debug \
965         doc/examples/hooks/ethers \
966         doc/examples/gnt-debug/README \
967         doc/examples/gnt-debug/delay0.json \
968         doc/examples/gnt-debug/delay50.json \
969         test/py/lockperf.py \
970         test/py/testutils.py \
971         test/py/mocks.py \
972         $(dist_TESTS) \
973         $(TEST_FILES) \
974         man/footer.rst \
975         $(manrst) \
976         $(maninput) \
977         qa/qa-sample.json \
978         $(qa_scripts) \
979         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
980         $(HS_PROG_SRCS) \
981         src/lint-hints.hs \
982         test/hs/cli-tests-defs.sh \
983         test/hs/offline-test.sh \
984         .ghci
985
986 man_MANS = \
987         man/ganeti-cleaner.8 \
988         man/ganeti-confd.8 \
989         man/ganeti-queryd.8 \
990         man/ganeti-listrunner.8 \
991         man/ganeti-masterd.8 \
992         man/ganeti-mond.8 \
993         man/ganeti-noded.8 \
994         man/ganeti-os-interface.7 \
995         man/ganeti-extstorage-interface.7 \
996         man/ganeti-rapi.8 \
997         man/ganeti-watcher.8 \
998         man/ganeti.7 \
999         man/gnt-backup.8 \
1000         man/gnt-cluster.8 \
1001         man/gnt-debug.8 \
1002         man/gnt-group.8 \
1003         man/gnt-network.8 \
1004         man/gnt-instance.8 \
1005         man/gnt-job.8 \
1006         man/gnt-node.8 \
1007         man/gnt-os.8 \
1008         man/gnt-storage.8 \
1009         man/hail.1 \
1010         man/harep.1 \
1011         man/hbal.1 \
1012         man/hcheck.1 \
1013         man/hinfo.1 \
1014         man/hscan.1 \
1015         man/hspace.1 \
1016         man/hroller.1 \
1017         man/htools.1 \
1018         man/mon-collector.7
1019
1020 # Remove extensions from all filenames in man_MANS
1021 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1022
1023 manrst = $(patsubst %,%.rst,$(mannoext))
1024 manhtml = $(patsubst %.rst,%.html,$(manrst))
1025 mangen = $(patsubst %.rst,%.gen,$(manrst))
1026 maninput = \
1027         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1028         $(patsubst %.html,%.html.in,$(manhtml)) \
1029         $(mangen)
1030
1031 TEST_FILES = \
1032         test/autotools/autotools-check-news.test \
1033         test/data/htools/clean-nonzero-score.data \
1034         test/data/htools/common-suffix.data \
1035         test/data/htools/empty-cluster.data \
1036         test/data/htools/hail-alloc-drbd.json \
1037         test/data/htools/hail-alloc-invalid-network.json \
1038         test/data/htools/hail-alloc-invalid-twodisks.json \
1039         test/data/htools/hail-alloc-restricted-network.json \
1040         test/data/htools/hail-alloc-twodisks.json \
1041         test/data/htools/hail-change-group.json \
1042         test/data/htools/hail-invalid-reloc.json \
1043         test/data/htools/hail-node-evac.json \
1044         test/data/htools/hail-reloc-drbd.json \
1045         test/data/htools/hbal-excl-tags.data \
1046         test/data/htools/hbal-split-insts.data \
1047         test/data/htools/hspace-tiered-dualspec.data \
1048         test/data/htools/hspace-tiered-ipolicy.data \
1049         test/data/htools/hspace-tiered-resourcetypes.data \
1050         test/data/htools/hspace-tiered.data \
1051         test/data/htools/invalid-node.data \
1052         test/data/htools/missing-resources.data \
1053         test/data/htools/multiple-master.data \
1054         test/data/htools/n1-failure.data \
1055         test/data/htools/rapi/groups.json \
1056         test/data/htools/rapi/info.json \
1057         test/data/htools/rapi/instances.json \
1058         test/data/htools/rapi/nodes.json \
1059         test/data/htools/unique-reboot-order.data \
1060         test/hs/shelltests/htools-balancing.test \
1061         test/hs/shelltests/htools-basic.test \
1062         test/hs/shelltests/htools-dynutil.test \
1063         test/hs/shelltests/htools-excl.test \
1064         test/hs/shelltests/htools-hail.test \
1065         test/hs/shelltests/htools-hroller.test \
1066         test/hs/shelltests/htools-hspace.test \
1067         test/hs/shelltests/htools-invalid.test \
1068         test/hs/shelltests/htools-multi-group.test \
1069         test/hs/shelltests/htools-no-backend.test \
1070         test/hs/shelltests/htools-rapi.test \
1071         test/hs/shelltests/htools-single-group.test \
1072         test/hs/shelltests/htools-text-backend.test \
1073         test/hs/shelltests/htools-mon-collector.test \
1074         test/data/bdev-drbd-8.0.txt \
1075         test/data/bdev-drbd-8.3.txt \
1076         test/data/bdev-drbd-disk.txt \
1077         test/data/bdev-drbd-net-ip4.txt \
1078         test/data/bdev-drbd-net-ip6.txt \
1079         test/data/bdev-rbd/json_output_empty.txt \
1080         test/data/bdev-rbd/json_output_extra_matches.txt \
1081         test/data/bdev-rbd/json_output_no_matches.txt \
1082         test/data/bdev-rbd/json_output_ok.txt \
1083         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1084         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1085         test/data/bdev-rbd/plain_output_new_ok.txt \
1086         test/data/bdev-rbd/plain_output_old_empty.txt \
1087         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1088         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1089         test/data/bdev-rbd/plain_output_old_ok.txt \
1090         test/data/bdev-rbd/output_invalid.txt \
1091         test/data/cert1.pem \
1092         test/data/cert2.pem \
1093         test/data/cluster_config_2.7.json \
1094         test/data/cluster_config_downgraded_2.7.json \
1095         test/data/instance-minor-pairing.txt \
1096         test/data/ip-addr-show-dummy0.txt \
1097         test/data/ip-addr-show-lo-ipv4.txt \
1098         test/data/ip-addr-show-lo-ipv6.txt \
1099         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1100         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1101         test/data/ip-addr-show-lo-oneline.txt \
1102         test/data/ip-addr-show-lo.txt \
1103         test/data/kvm_0.12.5_help.txt \
1104         test/data/kvm_0.15.90_help.txt \
1105         test/data/kvm_0.9.1_help.txt \
1106         test/data/kvm_0.9.1_help_boot_test.txt \
1107         test/data/kvm_1.0_help.txt \
1108         test/data/kvm_1.1.2_help.txt \
1109         test/data/NEWS_OK.txt \
1110         test/data/NEWS_previous_unreleased.txt \
1111         test/data/ovfdata/compr_disk.vmdk.gz \
1112         test/data/ovfdata/config.ini \
1113         test/data/ovfdata/corrupted_resources.ovf \
1114         test/data/ovfdata/empty.ini \
1115         test/data/ovfdata/empty.ovf \
1116         test/data/ovfdata/ganeti.mf \
1117         test/data/ovfdata/ganeti.ovf \
1118         test/data/ovfdata/gzip_disk.ovf \
1119         test/data/ovfdata/new_disk.vmdk \
1120         test/data/ovfdata/no_disk.ini \
1121         test/data/ovfdata/no_disk_in_ref.ovf \
1122         test/data/ovfdata/no_os.ini \
1123         test/data/ovfdata/no_ovf.ova \
1124         test/data/ovfdata/other/rawdisk.raw \
1125         test/data/ovfdata/ova.ova \
1126         test/data/ovfdata/rawdisk.raw \
1127         test/data/ovfdata/second_disk.vmdk \
1128         test/data/ovfdata/unsafe_path.ini \
1129         test/data/ovfdata/virtualbox.ovf \
1130         test/data/ovfdata/wrong_config.ini \
1131         test/data/ovfdata/wrong_extension.ovd \
1132         test/data/ovfdata/wrong_manifest.mf \
1133         test/data/ovfdata/wrong_manifest.ovf \
1134         test/data/ovfdata/wrong_ova.ova \
1135         test/data/ovfdata/wrong_xml.ovf \
1136         test/data/proc_drbd8.txt \
1137         test/data/proc_drbd80-emptyline.txt \
1138         test/data/proc_drbd83.txt \
1139         test/data/proc_drbd83_sync.txt \
1140         test/data/proc_drbd83_sync_want.txt \
1141         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1142         test/data/qa-minimal-nodes-instances-only.json \
1143         test/data/sys_drbd_usermode_helper.txt \
1144         test/data/vgreduce-removemissing-2.02.02.txt \
1145         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1146         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1147         test/data/vgs-missing-pvs-2.02.02.txt \
1148         test/data/vgs-missing-pvs-2.02.66.txt \
1149         test/data/xen-xm-info-4.0.1.txt \
1150         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1151         test/data/xen-xm-list-4.0.1-four-instances.txt \
1152         test/data/xen-xm-list-long-4.0.1.txt \
1153         test/data/xen-xm-uptime-4.0.1.txt \
1154         test/py/ganeti-cli.test \
1155         test/py/gnt-cli.test \
1156         test/py/import-export_unittest-helper
1157
1158
1159 python_tests = \
1160         doc/examples/rapi_testutils.py \
1161         test/py/cfgupgrade_unittest.py \
1162         test/py/docs_unittest.py \
1163         test/py/ganeti.asyncnotifier_unittest.py \
1164         test/py/ganeti.backend_unittest-runasroot.py \
1165         test/py/ganeti.backend_unittest.py \
1166         test/py/ganeti.bdev_unittest.py \
1167         test/py/ganeti.cli_unittest.py \
1168         test/py/ganeti.client.gnt_cluster_unittest.py \
1169         test/py/ganeti.client.gnt_instance_unittest.py \
1170         test/py/ganeti.client.gnt_job_unittest.py \
1171         test/py/ganeti.cmdlib_unittest.py \
1172         test/py/ganeti.compat_unittest.py \
1173         test/py/ganeti.confd.client_unittest.py \
1174         test/py/ganeti.config_unittest.py \
1175         test/py/ganeti.constants_unittest.py \
1176         test/py/ganeti.daemon_unittest.py \
1177         test/py/ganeti.errors_unittest.py \
1178         test/py/ganeti.hooks_unittest.py \
1179         test/py/ganeti.ht_unittest.py \
1180         test/py/ganeti.http_unittest.py \
1181         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1182         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1183         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1184         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1185         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1186         test/py/ganeti.hypervisor_unittest.py \
1187         test/py/ganeti.impexpd_unittest.py \
1188         test/py/ganeti.jqueue_unittest.py \
1189         test/py/ganeti.jstore_unittest.py \
1190         test/py/ganeti.locking_unittest.py \
1191         test/py/ganeti.luxi_unittest.py \
1192         test/py/ganeti.masterd.iallocator_unittest.py \
1193         test/py/ganeti.masterd.instance_unittest.py \
1194         test/py/ganeti.mcpu_unittest.py \
1195         test/py/ganeti.netutils_unittest.py \
1196         test/py/ganeti.objects_unittest.py \
1197         test/py/ganeti.opcodes_unittest.py \
1198         test/py/ganeti.outils_unittest.py \
1199         test/py/ganeti.ovf_unittest.py \
1200         test/py/ganeti.qlang_unittest.py \
1201         test/py/ganeti.query_unittest.py \
1202         test/py/ganeti.rapi.baserlib_unittest.py \
1203         test/py/ganeti.rapi.client_unittest.py \
1204         test/py/ganeti.rapi.resources_unittest.py \
1205         test/py/ganeti.rapi.rlib2_unittest.py \
1206         test/py/ganeti.rapi.testutils_unittest.py \
1207         test/py/ganeti.rpc_unittest.py \
1208         test/py/ganeti.runtime_unittest.py \
1209         test/py/ganeti.serializer_unittest.py \
1210         test/py/ganeti.server.rapi_unittest.py \
1211         test/py/ganeti.ssconf_unittest.py \
1212         test/py/ganeti.ssh_unittest.py \
1213         test/py/ganeti.storage_unittest.py \
1214         test/py/ganeti.tools.burnin_unittest.py \
1215         test/py/ganeti.tools.ensure_dirs_unittest.py \
1216         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1217         test/py/ganeti.tools.prepare_node_join_unittest.py \
1218         test/py/ganeti.uidpool_unittest.py \
1219         test/py/ganeti.utils.algo_unittest.py \
1220         test/py/ganeti.utils.filelock_unittest.py \
1221         test/py/ganeti.utils.hash_unittest.py \
1222         test/py/ganeti.utils.io_unittest-runasroot.py \
1223         test/py/ganeti.utils.io_unittest.py \
1224         test/py/ganeti.utils.log_unittest.py \
1225         test/py/ganeti.utils.lvm_unittest.py \
1226         test/py/ganeti.utils.mlock_unittest.py \
1227         test/py/ganeti.utils.nodesetup_unittest.py \
1228         test/py/ganeti.utils.process_unittest.py \
1229         test/py/ganeti.utils.retry_unittest.py \
1230         test/py/ganeti.utils.text_unittest.py \
1231         test/py/ganeti.utils.wrapper_unittest.py \
1232         test/py/ganeti.utils.x509_unittest.py \
1233         test/py/ganeti.utils_unittest.py \
1234         test/py/ganeti.vcluster_unittest.py \
1235         test/py/ganeti.workerpool_unittest.py \
1236         test/py/pycurl_reset_unittest.py \
1237         test/py/qa.qa_config_unittest.py \
1238         test/py/tempfile_fork_unittest.py
1239
1240 haskell_tests = test/hs/htest
1241
1242 dist_TESTS = \
1243         test/py/check-cert-expired_unittest.bash \
1244         test/py/daemon-util_unittest.bash \
1245         test/py/ganeti-cleaner_unittest.bash \
1246         test/py/import-export_unittest.bash \
1247         test/py/cli-test.bash \
1248         test/py/bash_completion.bash
1249
1250 if PY_UNIT
1251 dist_TESTS += $(python_tests)
1252 endif
1253
1254 nodist_TESTS =
1255 check_SCRIPTS =
1256
1257 if WANT_HSTESTS
1258 nodist_TESTS += $(haskell_tests)
1259 dist_TESTS += test/hs/offline-test.sh
1260 check_SCRIPTS += \
1261         test/hs/hpc-htools \
1262         test/hs/hpc-mon-collector \
1263         $(HS_BUILT_TEST_HELPERS)
1264 endif
1265
1266 TESTS = $(dist_TESTS) $(nodist_TESTS)
1267
1268 # Environment for all tests
1269 PLAIN_TESTS_ENVIRONMENT = \
1270         PYTHONPATH=. \
1271         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1272         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1273         $(RUN_IN_TEMPDIR)
1274
1275 # Environment for tests run by automake
1276 TESTS_ENVIRONMENT = \
1277         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1278
1279 all_python_code = \
1280         $(dist_sbin_SCRIPTS) \
1281         $(python_scripts) \
1282         $(pkglib_python_scripts) \
1283         $(nodist_pkglib_python_scripts) \
1284         $(nodist_tools_python_scripts) \
1285         $(pkgpython_PYTHON) \
1286         $(client_PYTHON) \
1287         $(cmdlib_PYTHON) \
1288         $(hypervisor_PYTHON) \
1289         $(rapi_PYTHON) \
1290         $(server_PYTHON) \
1291         $(pytools_PYTHON) \
1292         $(http_PYTHON) \
1293         $(confd_PYTHON) \
1294         $(masterd_PYTHON) \
1295         $(impexpd_PYTHON) \
1296         $(utils_PYTHON) \
1297         $(watcher_PYTHON) \
1298         $(noinst_PYTHON) \
1299         $(qa_scripts)
1300
1301 if PY_UNIT
1302 all_python_code += $(python_tests)
1303 endif
1304
1305 srclink_files = \
1306         man/footer.rst \
1307         test/py/check-cert-expired_unittest.bash \
1308         test/py/daemon-util_unittest.bash \
1309         test/py/ganeti-cleaner_unittest.bash \
1310         test/py/import-export_unittest.bash \
1311         test/py/cli-test.bash \
1312         test/py/bash_completion.bash \
1313         test/hs/offline-test.sh \
1314         test/hs/cli-tests-defs.sh \
1315         $(all_python_code) \
1316         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1317         $(docinput)
1318
1319 check_python_code = \
1320         $(BUILD_BASH_COMPLETION) \
1321         $(CHECK_IMPORTS) \
1322         $(CHECK_HEADER) \
1323         $(DOCPP) \
1324         $(all_python_code)
1325
1326 lint_python_code = \
1327         ganeti \
1328         ganeti/http/server.py \
1329         $(dist_sbin_SCRIPTS) \
1330         $(python_scripts) \
1331         $(pkglib_python_scripts) \
1332         $(BUILD_BASH_COMPLETION) \
1333         $(CHECK_IMPORTS) \
1334         $(CHECK_HEADER) \
1335         $(DOCPP) \
1336         $(PYTHON_BOOTSTRAP)
1337
1338 standalone_python_modules = \
1339         lib/rapi/client.py \
1340         tools/ganeti-listrunner
1341
1342 pep8_python_code = \
1343         ganeti \
1344         ganeti/http/server.py \
1345         $(dist_sbin_SCRIPTS) \
1346         $(python_scripts) \
1347         $(pkglib_python_scripts) \
1348         $(BUILD_BASH_COMPLETION) \
1349         $(CHECK_HEADER) \
1350         $(DOCPP) \
1351         $(PYTHON_BOOTSTRAP) \
1352         qa
1353
1354 test/py/daemon-util_unittest.bash: daemons/daemon-util
1355
1356 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1357
1358 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1359
1360 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1361         sed -f $(REPLACE_VARS_SED) < $< > $@
1362         chmod +x $@
1363
1364 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1365         sed -f $(REPLACE_VARS_SED) < $< > $@
1366         chmod +x $@
1367
1368 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1369         sed -f $(REPLACE_VARS_SED) < $< > $@
1370         chmod +x $@
1371
1372 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1373         sed -f $(REPLACE_VARS_SED) < $< > $@
1374         chmod +x $@
1375
1376 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1377         sed -f $(REPLACE_VARS_SED) < $< > $@
1378
1379 doc/examples/bash_completion: BC_ARGS = --compact
1380 doc/examples/bash_completion-debug: BC_ARGS =
1381
1382 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1383         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1384         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1385         daemons/ganeti-cleaner \
1386         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1387         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1388           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1389
1390 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1391         lib/build/shell_example_lexer.py \
1392         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1393         @echo "Checking $< for hardcoded paths..."
1394         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1395           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1396           exit 1; \
1397         fi
1398         set -e ; \
1399         trap 'echo auto-removing $@; rm $@' EXIT; \
1400         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1401         $(CHECK_MAN_REFERENCES) $@; \
1402         trap - EXIT
1403
1404 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1405         @test -n "$(PANDOC)" || \
1406           { echo 'pandoc' not found during configure; exit 1; }
1407         set -o pipefail -e; \
1408         trap 'echo auto-removing $@; rm $@' EXIT; \
1409         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1410           sed -e 's/\\@/@/g' > $@; \
1411         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1412         $(CHECK_MAN_DASHES) $@; \
1413         trap - EXIT
1414
1415 man/%.html.in: man/%.gen man/footer.rst
1416         @test -n "$(PANDOC)" || \
1417           { echo 'pandoc' not found during configure; exit 1; }
1418         set -o pipefail ; \
1419         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1420           sed -e 's/\\@/@/g' > $@
1421
1422 man/%: man/%.in  $(REPLACE_VARS_SED)
1423         sed -f $(REPLACE_VARS_SED) < $< > $@
1424
1425 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1426         sed -f $(REPLACE_VARS_SED) < $< > $@
1427
1428 vcs-version:
1429         if test -d .git; then \
1430           git describe > $@; \
1431         elif test ! -f $@ ; then \
1432           echo "Cannot auto-generate $@ file"; exit 1; \
1433         fi
1434
1435 .PHONY: clean-vcs-version
1436 clean-vcs-version:
1437         rm -f vcs-version
1438
1439 .PHONY: regen-vcs-version
1440 regen-vcs-version:
1441         @set -e; \
1442         cd $(srcdir); \
1443         if test -d .git; then \
1444           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1445           git describe > $$T; \
1446           if ! cmp --quiet $$T vcs-version; then \
1447             mv $$T vcs-version; \
1448           fi; \
1449         fi
1450
1451 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1452         vcs-version $(built_base_sources)
1453         set -e; \
1454         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1455         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1456
1457 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1458         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1459         lib/jstore.py $(RUN_IN_TEMPDIR) \
1460         $(CONVERT_CONSTANTS) $(built_base_sources) \
1461         | lib/_vcsversion.py
1462         set -e; \
1463         { cat $< ; \
1464           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1465         } > $@
1466
1467 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1468         hsc2hs -o $@ $<
1469
1470 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1471         $(built_base_sources)
1472         set -e; \
1473         { cat $< ; \
1474           echo ; \
1475           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1476             echo "import $$name ()" ; \
1477           done ; \
1478         } > $@
1479
1480 lib/_autoconf.py: Makefile | stamp-directories
1481         set -e; \
1482         { echo '# This file is automatically generated, do not edit!'; \
1483           echo '#'; \
1484           echo ''; \
1485           echo '"""Build-time configuration for Ganeti.'; \
1486           echo '';\
1487           echo 'This file is autogenerated by the build process.'; \
1488           echo 'For any changes you need to re-run ./configure (and'; \
1489           echo 'not edit by hand).'; \
1490           echo ''; \
1491           echo '"""'; \
1492           echo ''; \
1493           echo '# pylint: disable=C0301,C0324'; \
1494           echo '# because this is autogenerated, we do not want'; \
1495           echo '# style warnings' ; \
1496           echo ''; \
1497           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1498           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1499           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1500           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1501           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1502           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1503           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1504           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1505           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1506           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1507           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1508           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1509           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1510           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1511           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1512           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1513           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1514           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1515           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1516           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1517           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1518           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1519           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1520           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1521           echo "KVM_PATH = '$(KVM_PATH)'"; \
1522           echo "IP_PATH = '$(IP_PATH)'"; \
1523           echo "SOCAT_PATH = '$(SOCAT)'"; \
1524           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1525           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1526           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1527           echo "TOOLSDIR = '$(toolsdir)'"; \
1528           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1529           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1530           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1531           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1532           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1533           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1534           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1535           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1536           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1537           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1538           echo "RAPI_USER = '$(RAPI_USER)'"; \
1539           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1540           echo "CONFD_USER = '$(CONFD_USER)'"; \
1541           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1542           echo "QUERYD_USER = '$(QUERYD_USER)'"; \
1543           echo "QUERYD_GROUP = '$(QUERYD_GROUP)'"; \
1544           echo "NODED_USER = '$(NODED_USER)'"; \
1545           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1546           echo "MOND_USER = '$(MOND_USER)'"; \
1547           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1548           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1549           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1550           echo "HTOOLS = True"; \
1551           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1552           echo "XEN_CMD = '$(XEN_CMD)'"; \
1553           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1554           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1555           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1556 ## Write dictionary with man page name as the key and the section number as the
1557 ## value
1558           echo "MAN_PAGES = {"; \
1559           for i in $(notdir $(man_MANS)); do \
1560             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1561           done; \
1562           echo "}"; \
1563         } > $@
1564
1565 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1566         set -e; \
1567         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1568         { echo '# This file is automatically generated, do not edit!'; \
1569           echo '#'; \
1570           echo ''; \
1571           echo '"""Build-time VCS version number for Ganeti.'; \
1572           echo '';\
1573           echo 'This file is autogenerated by the build process.'; \
1574           echo 'For any changes you need to re-run ./configure (and'; \
1575           echo 'not edit by hand).'; \
1576           echo ''; \
1577           echo '"""'; \
1578           echo ''; \
1579           echo '# pylint: disable=C0301,C0324'; \
1580           echo '# because this is autogenerated, we do not want'; \
1581           echo '# style warnings' ; \
1582           echo ''; \
1583           echo "VCS_VERSION = '$$VCSVER'"; \
1584         } > $@
1585
1586 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1587         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1588
1589 $(SHELL_ENV_INIT): Makefile stamp-directories
1590         set -e; \
1591         { echo '# Allow overriding for tests'; \
1592           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1593           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1594           echo; \
1595           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1596           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1597           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1598           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1599           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1600         } > $@
1601
1602 ## Writes sed script to replace placeholders with build-time values. The
1603 ## additional quotes after the first @ sign are necessary to stop configure
1604 ## from replacing those values as well.
1605 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1606         set -e; \
1607         { echo 's#@''PREFIX@#$(prefix)#g'; \
1608           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1609           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1610           echo 's#@''BINDIR@#$(bindir)#g'; \
1611           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1612           echo 's#@''LIBDIR@#$(libdir)#g'; \
1613           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1614           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1615           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1616           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1617           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1618           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1619           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1620           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1621           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1622           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1623           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1624           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1625           echo 's#@''GNTQUERYDUSER@#$(QUERY_USER)#g'; \
1626           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1627           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1628           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1629           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1630           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1631           echo 's#@''GNTQUERYDGROUP@#$(QUERYD_GROUP)#g'; \
1632           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1633           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1634           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1635           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1636           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1637           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1638           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1639           echo; \
1640           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1641           echo '  r $(SHELL_ENV_INIT)'; \
1642           echo '  d'; \
1643           echo '}'; \
1644         } > $@
1645
1646 # Using deferred evaluation
1647 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1648 daemons/ganeti-watcher: MODULE = ganeti.watcher
1649 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1650 tools/burnin: MODULE = ganeti.tools.burnin
1651 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1652 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1653 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1654 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1655 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1656
1657 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1658         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1659         set -e; \
1660         { echo '#!/usr/bin/python'; \
1661           echo '# This file is automatically generated, do not edit!'; \
1662           echo "# Edit $(MODULE) instead."; \
1663           echo; \
1664           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1665           echo; \
1666           echo '# pylint: disable=C0103'; \
1667           echo '# C0103: Invalid name'; \
1668           echo; \
1669           echo 'import sys'; \
1670           echo 'import $(MODULE) as main'; \
1671           echo; \
1672           echo '# Temporarily alias commands until bash completion'; \
1673           echo '# generator is changed'; \
1674           echo 'if hasattr(main, "commands"):'; \
1675           echo '  commands = main.commands # pylint: disable=E1101'; \
1676           echo 'if hasattr(main, "aliases"):'; \
1677           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1678           echo; \
1679           echo 'if __name__ == "__main__":'; \
1680           echo '  sys.exit(main.Main())'; \
1681         } > $@
1682         chmod u+x $@
1683
1684 $(HS_BUILT_TEST_HELPERS): Makefile
1685         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1686         set -e; \
1687         { echo '#!/bin/sh'; \
1688           echo '# This file is automatically generated, do not edit!'; \
1689           echo "# Edit Makefile.am instead."; \
1690           echo; \
1691           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1692         } > $@
1693         chmod u+x $@
1694
1695 stamp-directories: Makefile
1696         $(MAKE) $(AM_MAKEFLAGS) ganeti
1697         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1698         touch $@
1699
1700 # We need to create symlinks because "make distcheck" will not install Python
1701 # files when building.
1702 stamp-srclinks: Makefile | stamp-directories
1703         set -e; \
1704         for i in $(srclink_files); do \
1705           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1706             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1707           fi; \
1708         done
1709         touch $@
1710
1711 .PHONY: ganeti
1712 ganeti:
1713         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1714
1715 .PHONY: check-dirs
1716 check-dirs: $(GENERATED_FILES)
1717         @set -e; \
1718         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1719           error=; \
1720           while read dir; do \
1721             case "$$dir" in \
1722               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1723               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1724             esac; \
1725           done; \
1726           for dir in $(DIRS); do \
1727             if ! test -d "$$dir"; then \
1728               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1729               error=1; \
1730             fi \
1731           done; \
1732           test -z "$$error"; \
1733         }
1734
1735 .PHONY: check-local
1736 check-local: check-dirs $(GENERATED_FILES)
1737         $(CHECK_PYTHON_CODE) $(check_python_code)
1738         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1739         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1740         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1741         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1742         error= ; \
1743         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1744           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1745           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1746             echo "Incorrect version in README, expected $$expver" >&2; \
1747             error=1; \
1748           fi; \
1749           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1750               doc/security.rst; do \
1751             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1752               "Documents Ganeti version $$expver"; then \
1753               echo "Incorrect version in $$file, expected $$expver" >&2; \
1754               error=1; \
1755             fi; \
1756           done; \
1757           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1758             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1759             error=1; \
1760           fi; \
1761           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1762             ".. Last updated for Ganeti $$expver"; then \
1763             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1764             error=1; \
1765           fi; \
1766         fi; \
1767         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1768           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1769             echo "Longest line in $$file is longer than 80 characters" >&2; \
1770             error=1; \
1771           fi; \
1772         done; \
1773         test -z "$$error"
1774
1775 .PHONY: hs-tests
1776 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1777         @rm -f htest.tix
1778         ./test/hs/htest
1779
1780 .PHONY: hs-shell
1781 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1782         @rm -f hpc-htools.tix hpc-mon-collector.tix
1783         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1784
1785 .PHONY: hs-check
1786 hs-check: hs-tests hs-shell
1787
1788 # E111: indentation is not a multiple of four
1789 # E121: continuation line indentation is not a multiple of four
1790 #       (since our indent level is not 4)
1791 # E125: continuation line does not distinguish itself from next logical line
1792 #       (since our indent level is not 4)
1793 # E127: continuation line over-indented for visual indent
1794 #       (since our indent level is not 4)
1795 # note: do NOT add E128 here; it's a valid style error in most cases!
1796 # I've seen real errors, but also some cases were we indent wrongly
1797 # due to line length; try to rework the cases where it is triggered,
1798 # instead of silencing it
1799 # E261: at least two spaces before inline comment
1800 # E501: line too long (80 characters)
1801 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1802
1803 # For excluding pep8 expects filenames only, not whole paths
1804 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1805
1806 LINT_TARGETS = pylint pylint-qa
1807 if HAS_PEP8
1808 LINT_TARGETS += pep8
1809 endif
1810 if HAS_HLINT
1811 LINT_TARGETS += hlint
1812 endif
1813
1814 .PHONY: lint
1815 lint: $(LINT_TARGETS)
1816
1817 .PHONY: pylint
1818 pylint: $(GENERATED_FILES)
1819         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1820         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1821
1822 .PHONY: pylint-qa
1823 pylint-qa: $(GENERATED_FILES)
1824         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1825         cd $(top_srcdir)/qa && \
1826           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1827           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1828
1829 .PHONY: pep8
1830 pep8: $(GENERATED_FILES)
1831         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1832         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1833           --repeat $(pep8_python_code)
1834
1835 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1836 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1837 .PHONY: hlint
1838 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1839         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1840         @rm -f doc/hs-lint.html
1841         if tty -s; then C="-c"; else C=""; fi; \
1842         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1843           --ignore "Use first" \
1844           --ignore "Use &&&" \
1845           --ignore "Use void" \
1846           --ignore "Reduce duplication" \
1847           --hint src/lint-hints \
1848           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1849         @if [ ! -f doc/hs-lint.html ]; then \
1850           echo "All good" > doc/hs-lint.html; \
1851         fi
1852
1853 # a dist hook rule for updating the vcs-version file; this is
1854 # hardcoded due to where it needs to build the file...
1855 dist-hook:
1856         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1857         rm -f $(top_distdir)/vcs-version
1858         cp -p $(srcdir)/vcs-version $(top_distdir)
1859
1860 # a distcheck hook rule for catching revision control directories
1861 distcheck-hook:
1862         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1863           echo "Found revision control files in final archive." 1>&2; \
1864           exit 1; \
1865         fi
1866         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1867           echo "Found Python byte code in final archive." 1>&2; \
1868           exit 1; \
1869         fi
1870         if find $(top_distdir) -name '*~' | grep .; then \
1871           echo "Found backup files in final archive." 1>&2; \
1872           exit 1; \
1873         fi
1874 # Empty files or directories should not be distributed. They can cause
1875 # unnecessary warnings for packagers. Directories used by automake during
1876 # distcheck must be excluded.
1877         if find $(top_distdir) -empty -and -not \( \
1878             -path $(top_distdir)/_build -or \
1879             -path $(top_distdir)/_inst \) | grep .; then \
1880           echo "Found empty files or directories in final archive." 1>&2; \
1881           exit 1; \
1882         fi
1883         if test -e $(top_distdir)/doc/man-html; then \
1884           echo "Found documentation including man pages in final archive" >&2; \
1885           exit 1; \
1886         fi
1887
1888 # Backwards compatible distcheck-release target
1889 distcheck-release: distcheck
1890
1891 distrebuildcheck: dist
1892         set -e; \
1893         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1894         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1895         cd $$builddir; \
1896         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1897         cd $(distdir); \
1898         ./configure; \
1899         $(MAKE) maintainer-clean; \
1900         cp $(abs_srcdir)/vcs-version .; \
1901         ./configure; \
1902         $(MAKE) $(AM_MAKEFLAGS)
1903
1904 dist-release: dist
1905         set -e; \
1906         for i in $(DIST_ARCHIVES); do \
1907           echo -n "Checking $$i ... "; \
1908           autotools/check-tar < $$i; \
1909           echo OK; \
1910         done
1911
1912 install-exec-local:
1913         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1914           "$(DESTDIR)${localstatedir}/log/ganeti" \
1915           "$(DESTDIR)${localstatedir}/run/ganeti"
1916
1917 .PHONY: apidoc
1918 if WANT_HSAPIDOC
1919 apidoc: py-apidoc hs-apidoc
1920 else
1921 apidoc: py-apidoc
1922 endif
1923
1924 .PHONY: py-apidoc
1925 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1926         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1927         $(RUN_IN_TEMPDIR) epydoc -v \
1928           --conf $(CURDIR)/epydoc.conf \
1929           --output $(CURDIR)/$(APIDOC_PY_DIR)
1930
1931 .PHONY: hs-apidoc
1932 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1933
1934 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1935         @test -n "$(HSCOLOUR)" || \
1936             { echo 'HsColour' not found during configure; exit 1; }
1937         @test -n "$(HADDOCK)" || \
1938             { echo 'haddock' not found during configure; exit 1; }
1939         rm -rf $(APIDOC_HS_DIR)/*
1940         for i in $(ALL_APIDOC_HS_DIRS); do \
1941           @mkdir_p@ $$i; \
1942           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1943         done
1944         set -e ; \
1945         export LC_ALL=en_US.UTF-8; \
1946         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1947         if [ "$(HS_PARALLEL3)" ]; \
1948         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1949         fi; \
1950         if [ "$(HS_REGEX_PCRE)" ]; \
1951         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1952         fi; \
1953         for file in $(HS_LIBTESTBUILT_SRCS); do \
1954           f_nosrc=$${file##src/}; \
1955           f_notst=$${f_nosrc##test/hs/}; \
1956           f_html=$${f_notst%%.hs}.html; \
1957           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1958         done ; \
1959         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1960           -t ganeti -p src/haddock-prologue \
1961           --source-module="%{MODULE/.//}.html" \
1962           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1963           $$OPTGHC \
1964           $(HS_LIBTESTBUILT_SRCS)
1965
1966 .PHONY: TAGS
1967 TAGS: $(GENERATED_FILES)
1968         rm -f TAGS
1969         $(GHC) -e ":etags" -v0 \
1970           $(filter-out -O -Werror,$(HFLAGS)) \
1971           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1972           $(HS_LIBTEST_SRCS)
1973         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1974           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1975           -path './qa/*.py' | \
1976           etags -l python -a -
1977
1978 .PHONY: coverage
1979
1980 COVERAGE_TESTS=
1981 if WANT_HTOOLS
1982 COVERAGE_TESTS += hs-coverage
1983 endif
1984 if PY_UNIT
1985 COVERAGE_TESTS += py-coverage
1986 endif
1987
1988 coverage: $(COVERAGE_TESTS)
1989
1990 .PHONY: py-coverage
1991 py-coverage: $(GENERATED_FILES) $(python_tests)
1992         @test -n "$(PYCOVERAGE)" || \
1993             { echo 'python-coverage' not found during configure; exit 1; }
1994         set -e; \
1995         COVERAGE=$(PYCOVERAGE) \
1996         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1997         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1998         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1999         $(PLAIN_TESTS_ENVIRONMENT) \
2000         $(abs_top_srcdir)/autotools/gen-py-coverage \
2001         $(python_tests)
2002
2003 .PHONY: hs-coverage
2004 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2005         rm -f *.tix
2006         $(MAKE) $(AM_MAKEFLAGS) hs-check
2007         @mkdir_p@ $(COVERAGE_HS_DIR)
2008         hpc sum --union $(HPCEXCL) \
2009           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2010         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2011         hpc report coverage-hs.tix
2012         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2013
2014 # Special "kind-of-QA" target for htools, needs special setup (all
2015 # tools compiled with -fhpc)
2016 .PHONY: live-test
2017 live-test: all
2018         set -e ; \
2019         cd src; \
2020         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2021         rm -f *.tix *.mix; \
2022         ./live-test.sh; \
2023         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2024           --output=live-test.tix ; \
2025         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2026         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2027           --srcdir=.. $(HPCEXCL) ; \
2028         hpc report --srcdir=.. live-test $(HPCEXCL)
2029
2030 commit-check: autotools-check distcheck lint apidoc
2031
2032 autotools-check:
2033         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2034   $(abs_top_srcdir)/test/autotools/*-*.test \
2035   -- --hide-successes
2036
2037 .PHONY: gitignore-check
2038 gitignore-check:
2039         @if [ -n "`git status --short`" ]; then \
2040           echo "Git status is not clean!" 1>&2 ; \
2041           git status --short; \
2042           exit 1; \
2043         fi
2044
2045 # target to rebuild all man pages (both groff and html output)
2046 .PHONY: man
2047 man: $(man_MANS) $(manhtml)
2048
2049 # Target that builds all binaries (including those that are not
2050 # rebuilt except when running the tests)
2051 .PHONY: really-all
2052 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2053
2054 # we don't need the ancient implicit rules:
2055 %: %,v
2056 %: RCS/%,v
2057 %: RCS/%
2058 %: s.%
2059 %: SCCS/s.%
2060
2061 -include ./Makefile.local
2062
2063 # vim: set noet :